<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Devcamp 123 ||Danh sách Học Sinh</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
</head>
<body class="hold-transition sidebar-mini">
<!-- Site wrapper -->
<div class="wrapper">
  <!-- Navbar -->
  <nav class="main-header navbar navbar-expand navbar-white navbar-light">
    <!-- Left navbar links -->
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="index3.html" class="nav-link">Home</a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Danh sách Học Sinh</a>
      </li>
    </ul>

  
  </nav>
  <!-- /.navbar -->

  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="index3.html" class="brand-link">
      <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">Devcamp 123</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar user (optional) -->
      <div class="user-panel mt-3 pb-3 mb-3 d-flex">
        <div class="image">
          <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
        </div>
        <div class="info">
          <a href="#" class="d-block">KhamDT</a>
        </div>
      </div>

    
      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item menu-open">
            <a href="#" class="nav-link  active">
              <i class="nav-icon fas fa-tachometer-alt"></i>
              <p>
                Dashboard
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="index.html" class="nav-link active">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Danh sách Học Sinh</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="index2.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Dashboard v2</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="index3.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Dashboard v3</p>
                </a>
              </li>
            </ul>
          </li>
          
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
    </div>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>Danh sách Học Sinh</h1>
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">Danh sách Học Sinh</li>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class = "container mt-4">
        <h2 class = "text-center">F200 - LỊCH SỬ HỌC TẬP</h2>
        <div class = "row jumbotron p-3 m-0">
            <div class = "col-md-12">
                    <div class = "row">
                      <button id="btn-insert-user" class="btn btn-warning">Thêm mới học sinh</button>
                    </div>
                    <div class = "row form-group" style="margin-top:20px;">
                        <div class = "col-2">
                            <label>Student</label>
                        </div>
                        <div class="col-sm-3">
                          <select id="select-student" class="form-control">
                  
                          </select>
                        </div>
                        <div class = "col-2">
                          <label>Subject</label>
                        </div>
                        <div class="col-sm-3">
                          <select id="select-subject" class="form-control">
                
                          </select>
                        </div>
                        <div class="col-sm-2">
                          <button class = "btn btn-success" id = "btn-filter-data">Lọc dữ liệu</button>
                        </div>
                    </div>
            </div>
        </div>
        <br>
        <div class="container">
          <table class="table table-bordered table-striped table-hover" id="student-table">
            <thead class = "text-center">
              <tr>
                <th>STT</th>
                <th>Sinh viên</th>
                <th>Môn học</th>
                <th>Điểm</th>
                <th>Ngày thi</th>
                <th>Action</th>
              </tr>
            </thead>
          </table>
        </div>
      </div>
      <!-- Create user modal -->
      <div id="insert-user-modal" class="modal fade " tabindex="-1">
        <div class="modal-dialog modal-xl">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="h5-modal-title">Thêm đơn hàng</h5>
                    <button class="close" data-dismiss="modal">&times;</button>
                </div>
                <div class="modal-body">
  
                   
                </div>
                <div class="modal-footer">
                    <button class="btn btn-success" id="btn-insert-order">Thêm đơn hàng mới</button>
                    <button class="btn btn-danger" id="btn-insert-cancel" data-dismiss="modal">Hủy bỏ</button>
                </div>
            </div>
        </div>
      </div>
       <!-- Edit user modal -->
       <div id="edit-user-modal" class="modal fade " tabindex="-1">
        <div class="modal-dialog modal-xl">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="h5-modal-title">Thêm đơn hàng</h5>
                    <button class="close" data-dismiss="modal">&times;</button>
                </div>
                <div class="modal-body">
  
                   
                </div>
                <div class="modal-footer">
                    <button class="btn btn-success" id="btn-insert-order">Thêm đơn hàng mới</button>
                    <button class="btn btn-danger" id="btn-insert-cancel" data-dismiss="modal">Hủy bỏ</button>
                </div>
            </div>
        </div>
      </div>
       <!-- Delete user modal -->
      <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
          <div class="modal-dialog">
              <div class="modal-content">
                  <div class="modal-header">
                      <h5 class="modal-title" id="h5-modal-title">User Delete Confirmation</h5>
                      <button class="close" data-dismiss="modal">&times;</button>
                  </div>
                  <div class="modal-body">
                      <label>Bạn có chắc chắn muốn xóa học sinh này không?</label>
                  </div>
                  <div class="modal-footer">
                      <button class="btn btn-danger" id="btn-modal-confirm-delete-user">Confirm</button>
                      <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                  </div>
              </div>
          </div>
      </div>
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->

  <footer class="main-footer">
    <div class="float-right d-none d-sm-block">
      <b>Version</b> 3.2.0
    </div>
    <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">Devcamp 123.io</a>.</strong> All rights reserved.
  </footer>

 
</div>
<!-- ./wrapper -->

<!-- jQuery -->
<script src="plugins/jquery/jquery.min.js"></script>
<!-- Bootstrap 4 -->
<script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
<!-- AdminLTE App -->
<script src="dist/js/adminlte.min.js"></script>
<!-- AdminLTE for demo purposes -->
<script src="dist/js/demo.js"></script>
<script>
     "use strict";
    /* Mảng userObjects là mảng chứa dữ liệu user. Từng phần tử là object
    */
    var gDataRow = "";
    var gOrderID = "";
    var gStudentId = "";
    var gStudents = [
      {
        id: 2, // tự tăng
        studentCode: "1356783",
        firstname: "Ngo Van",
        lastname: "Quan",
        age: 18,
        email: "quan@gmail.com",
        studyYear: 2015
      },
      {
        id: 3, // tự tăng
        studentCode: "1234567",
        firstname: "Tran Van",
        lastname: "Ninh",
        age: 20,
        email: "ninh@gmail.com",
        studyYear: 2019
      },
      {
        id: 4, // tự tăng
        studentCode: "1234568",
        firstname: "Nguyen Hoang",
        lastname: "Hai",
        age: 22,
        email: "hai@gmail.com",
        studyYear: 2020
      },
      {
        id: 5, // tự tăng
        studentCode: "1234569",
        firstname: "Le Duc",
        lastname: "Thanh",
        age: 23,
        email: "thanh@gmail.com",
        studyYear: 2021
      },
      {
        id: 6, // tự tăng
        studentCode: "1234579",
        firstname: "Dinh Van",
        lastname: "An",
        age: 21,
        email: "an@gmail.com",
        studyYear: 2020
      }
    ];

    var gSubjects = [
      {
        id: 5, // tự tăng
        subjectCode: "MATH101",
        subjectName: "Toán cao cấp 1"
      },
      {
        id: 6, // tự tăng
        subjectCode: "PHYS101",
        subjectName: "Vật lý đại cương 1"
      },
      {
        id: 7, // tự tăng
        subjectCode: "CHEM101",
        subjectName: "Hóa đại cương 1"
      },
      {
        id: 8, // tự tăng
        subjectCode: "BIOL101",
        subjectName: "Sinh học đại cương 1"
      },
      {
        id: 9, // tự tăng
        subjectCode: "LITE101",
        subjectName: "Văn học đương đại 1"
      }
      // điền thêm 04 môn học nữa
    ];

    var gGrades = [
      {
        id: 2, // tự tăng
        studentId: 2,
        subjectId: 5,
        grade: 8,
        examDate: "13/04/2021"
      },
      {
        id: 3, // tự tăng
        studentId: 3,
        subjectId: 6,
        grade: 8,
        examDate: "14/05/2021"
      },
      {
        id: 4, // tự tăng
        studentId: 5,
        subjectId: 7,
        grade: 8,
        examDate: "19/06/2021"
      },
      {
        id: 5, // tự tăng
        studentId: 6,
        subjectId: 7,
        grade: 9,
        examDate: "20/07/2021"
      },
      {
        id: 6, // tự tăng
        studentId: 4,
        subjectId: 8,
        grade: 9,
        examDate: "30/08/2021"
      },
      {
        id: 7, // tự tăng
        studentId: 6,
        subjectId: 9,
        grade: 9,
        examDate: "30/09/2021"
      },
      {
        id: 8, // tự tăng
        studentId: 4,
        subjectId: 5,
        grade: 7,
        examDate: "15/10/2021"
      },
      {
        id: 9, // tự tăng
        studentId: 5,
        subjectId: 5,
        grade: 6,
        examDate: "15/02/2021"
      },
      {
        id: 10, // tự tăng
        studentId: 3,
        subjectId: 9,
        grade: 7,
        examDate: "15/01/2021"
      },
      {
        id: 11, // tự tăng
        studentId: 4,
        subjectId: 7,
        grade: 7,
        examDate: "28/02/2021"
      }
      // điền thêm 9 kết quả thi nữa
    ];
    console.log("Mảng Sinh viên: ");
    console.log(gStudents);
    console.log("Mảng Môn học: ");
    console.log(gSubjects);
    console.log("Mảng Điểm: ")
    console.log(gGrades);
    const gARRAY_COL_NAME = ["stt", "student", "subject", "grade", "date","action"];
    const gCOL_STT = 0;
    const gCOL_STUDENT = 1;
    const gCOL_SUBJECT = 2;
    const gCOL_GRADE = 3;
    const gCOL_DATE = 4;
    const gCOL_ACTION = 5;
    var gSTT = 0;
    var gObjectData = [];
    $('#student-table').DataTable({        
          columns: [  
            { data: gARRAY_COL_NAME[gCOL_STT] },
            { data: gARRAY_COL_NAME[gCOL_STUDENT] },
            { data: gARRAY_COL_NAME[gCOL_SUBJECT] },
            { data: gARRAY_COL_NAME[gCOL_GRADE] },
            { data: gARRAY_COL_NAME[gCOL_DATE] },
            { data: gARRAY_COL_NAME[gCOL_ACTION] },
          ],
          columnDefs: [
              { 
                targets:gCOL_STT, 
                render: function(){
                  gSTT++;
                  return gSTT;
                }
              },
              { 
                targets:gCOL_SUBJECT, 
                className: "text-center"
              },
              { 
                targets:gCOL_GRADE, 
                className: "text-center"
              },
              { 
                targets:gCOL_DATE, 
                className: "text-center"
              },
              {
                targets: gCOL_ACTION,
                className: "text-center",
                defaultContent: `
                  <button class="btn btn-link" data-toggle="tooltip" data-placement="bottom" title="Edit" id = "btn-edit"><i class="fas fa-edit" text-success style = "cursor:pointer; color: green"></i></button>
                  <button class="btn btn-link" data-toggle="tooltip" data-placement="bottom" title="Delete" id = "btn-delete"><i class="fas fa-trash-alt" text-success style = "cursor:pointer; color: red"></i></button>
                `
              }
          ],
          autoWidth: false
    });

    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    $(document).ready(function(){
    onPageLoading();
    
    $("#btn-filter-data").on("click",function(){
      onBtnFilterClick();
    })

    $("#btn-insert-user").on("click", function() {
      onBtnInsertUserClick();
    })

    $("#student-table").on("click", "#btn-edit", function() {
      onBtnEditUserClick(this);
    })

    $("#student-table").on("click", "#btn-delete", function() {
      onBtnDeleteUserClick(this);
    })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */  
      function onPageLoading(){
        var bI = 0;
        while (bI < gGrades.length) {
          var bObject = {'id': bI, 'student': getStudentInfoFromId(gGrades[bI].studentId), 'subject': getSubjectInfoFromId(gGrades[bI].subjectId), 'grade': gGrades[bI].grade, 'date': gGrades[bI].examDate};
          gObjectData.push(bObject);  
          bI++;  
          }
        console.log("object");
        console.log(gObjectData);
        loadDataToUserTable(gObjectData);
        loadDataToSelectStudent(gStudents);
        loadDataToSelectSubject(gSubjects);
      }

      function onBtnInsertUserClick(paramButtonElement) {
        "use strict";
        console.log("Nút Thêm mới được nhấn!");
        $("#btn-insert-user").modal("show");
    }

    function onBtnEditUserClick(paramButtonElement) {
        "use strict";
        console.log("Nút Sửa được nhấn!");
        var vRowClick = $(paramButtonElement).closest("tr"); // xác định tr chứa nút bấm được click
        var vTable = $("#order-table").DataTable(); // tạo biến truy xuất đến DataTable
        var vDataRow = vTable.row(vRowClick).data(); // Dữ liệu của hàng dữ liệu chứa nút bấm được click
        //gDataRow = vDataRow;
        //gStudentId = vDataRow.studentCode;
        //console.log(gStudentId);

        // call Api lấy dữ liệu đơn hàng qua OrderId
        //callApiToGetDataByOrderID(gOrderID);
        // gán dữ liệu vào modal sửa đơn hàng
        //loadDataToModal(gOrderObjectId);
        // hiện modal trắng sửa đơn hàng lên
        $("#edit-user-modal").modal("show");
    }

        function onBtnDeleteUserClick(paramDelete){
          "use strict";
          console.log('Nút delete được ấn !!!')
          var vCurrentRow = $(paramDelete).closest('tr');
          var vTable = $('#order-table').DataTable();
          gDataRow = vTable.row(vCurrentRow).data();
          console.log(gDataRow)
          $('#delete-confirm-modal').modal('show');
        }








      function loadDataToUserTable(paramObjectUsers){
        console.log("Hàm load table");
        var vTable = $("#student-table").DataTable();
        vTable.clear();
        vTable.rows.add(paramObjectUsers);
        vTable.draw();
      }
      function loadDataToSelectStudent(paramStudentObj){
        "use strict";
        // Thêm option mặc định
        $('#select-student').append($('<option>', {
            value: "0",
            text: "=== Chọn Sinh viên ==="
        }));
        // Thêm các option từ dữ liệu
        for(var bI = 0; bI < paramStudentObj.length; bI++){
          $('#select-student').append($('<option>', {
            value: paramStudentObj[bI].studentCode,
            text: paramStudentObj[bI].firstname + " "+ paramStudentObj[bI].lastname
          }));
        }      
      }
      function loadDataToSelectSubject(paramSubjectObj){
        "use strict";
        // Thêm option mặc định
        $('#select-subject').append($('<option>', {
            value: "0",
            text: "=== Chọn Môn học ==="
        }));
        // Thêm các option từ dữ liệu
        for(var bI = 0; bI < paramSubjectObj.length; bI++){
          $('#select-subject').append($('<option>', {
            value: paramSubjectObj[bI].subjectCode,
            text: paramSubjectObj[bI].subjectName
          }));
        }      
      }
      function getStudentInfoFromId(paramId){
        "use strict";
        var vStudentInfo = "";
        for (var bI= 0; bI< gStudents.length; bI++){
            if (gStudents[bI].id == paramId){
              vStudentInfo = gStudents[bI].firstname + " " + gStudents[bI].lastname;
            }
        }
        return vStudentInfo;
      }
      function getSubjectInfoFromId(paramId){
        "use strict";
        var vSubjectInfo = "";
        for (var bI= 0; bI< gSubjects.length; bI++){
            if (gSubjects[bI].id == paramId){
              vSubjectInfo = gSubjects[bI].subjectName;
            }
        }
        return vSubjectInfo;
    } 
    // Hàm xử lý khi click nút filter
    function onBtnFilterClick(){
        "use strict";
        //debugger;
        console.log("Filter");
        var vObjectFilter = {
          student: "",
          subject: ""
        }

        // Bước 1: Thu thập dữ liệu từ select
        getDataFromSelect(vObjectFilter);
        console.log(vObjectFilter);
        // Bước 2: Kiểm tra dữ liệu - bỏ qua

        // Bước 3: Lọc dữ liệu
        var vResultFilter = filterData(vObjectFilter);
        console.log(vResultFilter);
        // Bước 4: Hiển thị dữ liệu lên Datatable
        loadDataToUserTable(vResultFilter);
      }
      function getDataFromSelect(paramObjectFilter){
        "use strict";
        paramObjectFilter.student = $("#select-student option:selected").text();
        paramObjectFilter.subject = $("#select-subject option:selected").text();
      }
      function filterData(paramObjectFilter){
      "use strict";
      
      var vFilter = gObjectData.filter(function(item){
        if (paramObjectFilter.student != 0 && paramObjectFilter.subject != 0){
          return (item.student == paramObjectFilter.student && item.subject == paramObjectFilter.subject)
        }
        if (paramObjectFilter.student === 0 && paramObjectFilter.subject != 0) {
          return (item.student == paramObjectFilter.student || paramObjectFilter.student == 0 || item.subject == paramObjectFilter.subject || paramObjectFilter.subject == 0);
        } 
        if (paramObjectFilter.student != 0 && paramObjectFilter.subject === 0) {
          return (item.student == paramObjectFilter.student || paramObjectFilter.student == 0 || item.subject == paramObjectFilter.subject || paramObjectFilter.subject == 0);
        } 
      })
      return vFilter;
    }
  })
</script>
</body>
</html>